std::unique_ptr< _Tp, _Dp >(3)

NAME
std::unique_ptr< _Tp, _Dp > -

SYNOPSIS

  Public Types
typedef _Dp deleter_type
typedef _Tp element_type
typedef _Pointer::type pointer

  Public Member Functions
constexpr unique_ptr () noexcept
unique_ptr (pointer __p) noexcept
unique_ptr (pointer __p, typename conditional< is_reference< deleter_type >::value, deleter_type, const deleter_type & >::type __d) noexcept
unique_ptr (pointer __p, typename remove_reference< deleter_type >::type &&__d) noexcept
constexpr unique_ptr (nullptr_t) noexcept
unique_ptr (unique_ptr &&__u) noexcept
template<typename _Up , typename _Ep , typename = _Require< is_convertible<typename unique_ptr<_Up, _Ep>::pointer, pointer>, __not_<is_array<_Up>>, typename conditional<is_reference<_Dp>::value, is_same<_Ep, _Dp>, is_convertible<_Ep, _Dp>>::type>> unique_ptr (unique_ptr< _Up, _Ep > &&__u) noexcept
template<typename _Up , typename > unique_ptr (auto_ptr< _Up > &&__u) noexcept
unique_ptr (const unique_ptr &)=delete
~unique_ptr () noexcept
pointer get () const noexcept
deleter_type & get_deleter () noexcept
const deleter_type & get_deleter () const noexcept
operator bool () const noexcept
add_lvalue_reference< element_type >::type operator* () const
pointer operator-> () const noexcept
unique_ptr & operator= (unique_ptr &&__u) noexcept
template<typename _Up , typename _Ep > enable_if< __and_< is_convertible< typename unique_ptr< _Up, _Ep >::pointer, pointer >, __not_< is_array< _Up > > >::value, unique_ptr & >::type operator= (unique_ptr< _Up, _Ep > &&__u) noexcept
unique_ptr & operator= (nullptr_t) noexcept
unique_ptr & operator= (const unique_ptr &)=delete
pointer release () noexcept
void reset (pointer __p=pointer()) noexcept
void swap (unique_ptr &__u) noexcept

Detailed Description

  template<typename _Tp, typename _Dp = default_delete<_Tp>>class std::unique_ptr< _Tp, _Dp >
20.7.1.2 unique_ptr for single objects.

Definition at line 129 of file unique_ptr.h.

Constructor & Destructor Documentation

  template<typename _Tp, typename _Dp = default_delete<_Tp>> constexpr std::unique_ptr< _Tp, _Dp >::unique_ptr () [inline], [noexcept]

Default constructor, creates a unique_ptr that owns nothing.

Definition at line 157 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> std::unique_ptr< _Tp, _Dp >::unique_ptr (pointer __p) [inline], [explicit], [noexcept]
Takes ownership of a pointer.

Parameters:
    __p A pointer to an object of element_type

The deleter will be value-initialized.

Definition at line 169 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> std::unique_ptr< _Tp, _Dp >::unique_ptr (pointer __p, typename conditional< is_reference< deleter_type >::value, deleter_type, const deleter_type & >::type __d) [inline], [noexcept]
Takes ownership of a pointer.

Parameters:
    __p A pointer to an object of element_type
    __d A reference to a deleter.

The deleter will be initialized with __d

Definition at line 181 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> std::unique_ptr< _Tp, _Dp >::unique_ptr (pointer __p, typename remove_reference< deleter_type >::type && __d) [inline], [noexcept]
Takes ownership of a pointer.

Parameters:
    __p A pointer to an object of element_type
    __d An rvalue reference to a deleter.

The deleter will be initialized with std::move(__d)

Definition at line 193 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> constexpr std::unique_ptr< _Tp, _Dp >::unique_ptr (nullptr_t) [inline], [noexcept]

Creates a unique_ptr that owns nothing.

Definition at line 200 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> std::unique_ptr< _Tp, _Dp >::unique_ptr (unique_ptr< _Tp, _Dp > && __u) [inline], [noexcept]

Move constructor.

Definition at line 205 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> template<typename _Up , typename _Ep , typename = _Require< is_convertible<typename unique_ptr<_Up, _Ep>::pointer, pointer>, __not_<is_array<_Up>>, typename conditional<is_reference<_Dp>::value, is_same<_Ep, _Dp>, is_convertible<_Ep, _Dp>>::type>> std::unique_ptr< _Tp, _Dp >::unique_ptr (unique_ptr< _Up, _Ep > && __u) [inline], [noexcept]

Converting constructor from another type. Requires that the pointer owned by __u is convertible to the type of pointer owned by this object, __u does not own an array, and __u has a compatible deleter type.

Definition at line 220 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> std::unique_ptr< _Tp, _Dp >::~unique_ptr () [inline], [noexcept]

Destructor, invokes the deleter if the stored pointer is not null.

Definition at line 232 of file unique_ptr.h.

Member Function Documentation

  template<typename _Tp, typename _Dp = default_delete<_Tp>> pointer std::unique_ptr< _Tp, _Dp >::get () const [inline], [noexcept]

Return the stored pointer.

Definition at line 304 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> deleter_type& std::unique_ptr< _Tp, _Dp >::get_deleter () [inline], [noexcept]

Return a reference to the stored deleter.

Definition at line 309 of file unique_ptr.h.

Referenced by std::unique_ptr< bool[]>::operator=(), std::unique_ptr< _Tp[], _Dp >::operator=(), std::unique_ptr< bool[]>::reset(), std::unique_ptr< _Tp[], _Dp >::reset(), std::unique_ptr< bool[]>::~unique_ptr(), and std::unique_ptr< _Tp[], _Dp >::~unique_ptr().

  template<typename _Tp, typename _Dp = default_delete<_Tp>> const deleter_type& std::unique_ptr< _Tp, _Dp >::get_deleter () const [inline], [noexcept]

Return a reference to the stored deleter.

Definition at line 314 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> std::unique_ptr< _Tp, _Dp >::operator bool () const [inline], [explicit], [noexcept]

Return true if the stored pointer is not null.

Definition at line 318 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> add_lvalue_reference<element_type>::type std::unique_ptr< _Tp, _Dp >::operator* () const [inline]

Dereference the stored pointer.

Definition at line 288 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> pointer std::unique_ptr< _Tp, _Dp >::operator-> () const [inline], [noexcept]

Return the stored pointer.

Definition at line 296 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> unique_ptr& std::unique_ptr< _Tp, _Dp >::operator= (unique_ptr< _Tp, _Dp > && __u) [inline], [noexcept]

Move assignment operator.

Parameters:
    __u The object to transfer ownership from.

Invokes the deleter first if this object owns a pointer.

Definition at line 249 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> template<typename _Up , typename _Ep > enable_if< __and_< is_convertible<typename unique_ptr<_Up, _Ep>::pointer, pointer>, __not_<is_array<_Up> > >::value, unique_ptr&>::type std::unique_ptr< _Tp, _Dp >::operator= (unique_ptr< _Up, _Ep > && __u) [inline], [noexcept]

Assignment from another type.

Parameters:
    __u The object to transfer ownership from, which owns a convertible pointer to a non-array object.

Invokes the deleter first if this object owns a pointer.

Definition at line 269 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> unique_ptr& std::unique_ptr< _Tp, _Dp >::operator= (nullptr_t) [inline], [noexcept]

Reset the unique_ptr to empty, invoking the deleter if necessary.

Definition at line 278 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> pointer std::unique_ptr< _Tp, _Dp >::release () [inline], [noexcept]

Release ownership of any stored pointer.

Definition at line 325 of file unique_ptr.h.

  template<typename _Tp, typename _Dp = default_delete<_Tp>> void std::unique_ptr< _Tp, _Dp >::reset (pointer __p = pointer()) [inline], [noexcept]

Replace the stored pointer.

Parameters:
    __p The new pointer to store.

The deleter will be invoked if a pointer is already owned.

Definition at line 339 of file unique_ptr.h.

Referenced by std::unique_ptr< bool[]>::operator=(), and std::unique_ptr< _Tp[], _Dp >::operator=().

  template<typename _Tp, typename _Dp = default_delete<_Tp>> void std::unique_ptr< _Tp, _Dp >::swap (unique_ptr< _Tp, _Dp > & __u) [inline], [noexcept]

Exchange the pointer and deleter with another object.

Definition at line 349 of file unique_ptr.h.

Referenced by std::unique_ptr< bool[]>::reset(), std::unique_ptr< _Tp[], _Dp >::reset(), std::unique_ptr< bool[]>::swap(), and std::unique_ptr< _Tp[], _Dp >::swap().

Author

Generated automatically by Doxygen for libstdc++ from the source code.